diff --speed-large-files --minimal -Nru tmp/netqmail-1.06/EXTTODO work/netqmail-1.06/EXTTODO
--- tmp/netqmail-1.06/EXTTODO	1969-12-31 18:00:00.000000000 -0600
+++ work/netqmail-1.06/EXTTODO	2016-05-06 14:30:29.000000000 -0500
@@ -0,0 +1,114 @@
+EXTTODO by Claudio Jeker <jeker@n-r-g.com> and 
+Andre Oppermann <opi@nrg4u.com>
+(c) 1998,1999,2000,2001,2002 Internet Business Solutions Ltd.
+
+The EXTTODO patch is a part of the qmail-ldap patch.
+This patches for qmail come with NO WARRANTY.
+
+These patches are under the BSD license.
+
+RELEASE: 5. Jan. 2003
+
+EXTTODO:
+======================
+
+TOC:
+ WHAT DOES IT DO
+ INSTALL
+ CONFIG FILES
+ SETUP
+ BIG PICTURE
+
+NEWS:
+ 
+ This is the first release of the EXTTODO patch.
+
+================================================================================
+
+WHAT DOES IT DO
+
+ The exttodo patch addresses a problem known as the silly qmail (queue)
+ problem. This problem is found only on system with high injection rates.
+
+ qmail with a big local and remote concurrency could deliver a tremendous 
+ amount of messages but normally this can not be achieved because qmail-send
+ becomes a bottleneck on those high volumes servers.
+ qmail-send preprocesses all new messages before distributing them for local
+ or remote delivering. In one run qmail-send does one todo run but has the 
+ ability to close multiple jobs. Because of this layout qmail-send can not 
+ feed all the new available (local/remote) delivery slots and therefor it is 
+ not possible to achieve the maximum throughput.
+ This would be a minor problem if one qmail-send run could be done in extreme
+ short time but because of many file system calls (fsync and (un)link) a todo
+ run is expensive and throttles the throughput.
+
+ The exttodo patch tries to solve the problem by moving the todo routine into 
+ an external program. This reduces the run time in qmail-send.
+
+ exttodo adds a new program to qmail called qmail-todo. qmail-todo prepares
+ incoming messages for local and remote delivering (by creating info/<messid>
+ local/<messid> and remote/<messid> and removing todo/<messid>). See also
+ INTERNALS. As next qmail-todo transmits the <messid> to qmail-send which will
+ add this message into the priority queue which schedules the message for 
+ delivery. 
+
+INSTALL
+
+ To enable the exttodo patch you need to define EXTERNAL_TODO while compiling
+ qmail(-ldap) this can be done with the -D flag of cc (e.g. cc -DEXTERNAL_TODO).
+
+ NOTE: the exttodo patch can also be used on qmail systems without the 
+ qmail-ldap patch.
+ 
+================================================================================
+
+CONFIG FILES
+
+ No additional control files are used or needed.
+
+================================================================================
+
+SETUP
+
+ qmail-todo will be started by qmail-start and therefor no additional setup
+ is needed.
+
+ To verify that exttodo is running just check if qmail-todo is running.
+
+================================================================================
+
+BIG PICTURE
+
+               +-------+   +-------+
+               | clean |   | clean |
+               +--0-1--+   +--0-1--+       +-----------+
+         trigger  ^ |         ^ |        +->0,1 lspawn |
+            |     | v         | v       /  +-----------+
+ +-------+  v  +--2-3--+   +--5-6--+   /
+ |       |  |  |       0<--7     1,2<-+
+ | queue |--+--| todo  |   | send  |
+ |       |  |  |       1-->8     3,4<-+
+ +-------+     +-------+   +---0---+   \
+                               |        \  +-----------+
+                               v         +->0,1 rspwan |
+                           +---0---+       +-----------+
+                           | logger|
+                           +-------+
+
+Communication between qmail-send and qmail-todo
+
+todo -> send:
+   D[LRB]<mesgid>\0
+          Start delivery for new message with id <messid>.
+          the character L, R or B defines the type
+          of delivery, local, remote or both respectively.
+   L<string>\0
+          Dump string to the logger without adding additional \n or similar.
+send -> todo:
+   H      Got a SIGHUP reread ~/control/locals and ~/control/virtualdomains
+   X      Quit ASAP.
+
+qmail-todo sends "\0" terminated messages whereas qmail-send just send one
+character to qmail-todo.
+
+
diff --speed-large-files --minimal -Nru tmp/netqmail-1.06/EXTTODO-INFO work/netqmail-1.06/EXTTODO-INFO
--- tmp/netqmail-1.06/EXTTODO-INFO	1969-12-31 18:00:00.000000000 -0600
+++ work/netqmail-1.06/EXTTODO-INFO	2016-05-06 14:30:29.000000000 -0500
@@ -0,0 +1,11 @@
+Files modified:
+Makefile
+EXTTODO
+FILES
+TARGETS
+qmail-send.c
+qmail-todo.c
+qmail-start.c
+hier.c
+install-big.c
+
diff --speed-large-files --minimal -Nru tmp/netqmail-1.06/FILES work/netqmail-1.06/FILES
--- tmp/netqmail-1.06/FILES	2007-11-30 14:22:54.000000000 -0600
+++ work/netqmail-1.06/FILES	2016-05-06 14:30:29.000000000 -0500
@@ -432,3 +432,4 @@
 tcp-environ.5
 constmap.h
 constmap.c
+qmail-todo.c
diff --speed-large-files --minimal -Nru tmp/netqmail-1.06/FILES.auth work/netqmail-1.06/FILES.auth
--- tmp/netqmail-1.06/FILES.auth	1969-12-31 18:00:00.000000000 -0600
+++ work/netqmail-1.06/FILES.auth	2016-05-06 14:30:55.000000000 -0500
@@ -0,0 +1,27 @@
+The qmail-smtpd Auth patch modifies the following QMAIL 1.03 files:
+
+= TARGETS
+= Makefile
+= qmail-smtpd.c
+= qmail-smtpd.8
+= qmail-remote.c
+= qmail-remote.8
+= qmail-showctl.c
+= qmail-control.9
+
+Added files:
+
++ base64.c
++ base64.h
++ case_startb.c
++ hmac_md5.h
++ hmac_md5.c
++ global.h
++ md5.h
++ md5c.c
+
+Informational files:
+
+% install_auth.sh  (Installation shell script)
+% LICENSE.authentication (some sort of ...)
+% README.auth
diff --speed-large-files --minimal -Nru tmp/netqmail-1.06/FILES~ work/netqmail-1.06/FILES~
--- tmp/netqmail-1.06/FILES~	1969-12-31 18:00:00.000000000 -0600
+++ work/netqmail-1.06/FILES~	2007-11-30 14:22:54.000000000 -0600
@@ -0,0 +1,434 @@
+BLURB
+BLURB2
+BLURB3
+BLURB4
+README
+FAQ
+INSTALL
+INSTALL.alias
+INSTALL.ctl
+INSTALL.ids
+INSTALL.maildir
+INSTALL.mbox
+INSTALL-1.03
+INSTALL.vsm
+REMOVE.sendmail
+REMOVE.binmail
+TEST.deliver
+TEST.receive
+UPGRADE
+THOUGHTS
+TODO
+THANKS
+CHANGES
+SECURITY
+INTERNALS
+SENDMAIL
+PIC.local2alias
+PIC.local2ext
+PIC.local2local
+PIC.local2rem
+PIC.local2virt
+PIC.nullclient
+PIC.relaybad
+PIC.relaygood
+PIC.rem2local
+FILES
+VERSION
+SYSDEPS
+TARGETS
+Makefile
+BIN.README
+BIN.Makefile
+idedit.c
+conf-break
+auto_break.h
+conf-spawn
+auto_spawn.h
+chkspawn.c
+conf-split
+auto_split.h
+conf-patrn
+auto_patrn.h
+conf-users
+conf-groups
+auto_uids.h
+auto_usera.h
+extra.h
+addresses.5
+except.1
+bouncesaying.1
+condredirect.1
+dot-qmail.9
+envelopes.5
+forgeries.7
+forward.1
+maildir2mbox.1
+maildirmake.1
+maildirwatch.1
+mailsubj.1
+mbox.5
+preline.1
+qbiff.1
+qmail-clean.8
+qmail-command.8
+qmail-control.9
+qmail-getpw.9
+qmail-header.5
+qmail-inject.8
+qmail-limits.9
+qmail-local.8
+qmail-log.5
+qmail-lspawn.8
+qmail-newmrh.9
+qmail-newu.9
+qmail-pop3d.8
+qmail-popup.8
+qmail-pw2u.9
+qmail-qmqpc.8
+qmail-qmqpd.8
+qmail-qmtpd.8
+qmail-qread.8
+qmail-qstat.8
+qmail-queue.8
+qmail-remote.8
+qmail-rspawn.8
+qmail-send.9
+qmail-showctl.8
+qmail-smtpd.8
+qmail-start.9
+qmail-tcpok.8
+qmail-tcpto.8
+qmail-users.9
+qmail.7
+qreceipt.1
+splogger.8
+tcp-env.1
+config.sh
+config-fast.sh
+qmail-clean.c
+qmail-getpw.c
+qmail-inject.c
+qmail-local.c
+qmail-lspawn.c
+qmail-newmrh.c
+qmail-newu.c
+qmail-pop3d.c
+qmail-popup.c
+qmail-pw2u.c
+qmail-qmqpc.c
+qmail-qmqpd.c
+qmail-qmtpd.c
+qmail-qread.c
+qmail-qstat.sh
+qmail-queue.c
+qmail-remote.c
+qmail-rspawn.c
+qmail-send.c
+qmail-showctl.c
+qmail-smtpd.c
+qmail-start.c
+qmail-tcpok.c
+qmail-tcpto.c
+spawn.c
+dnscname.c
+dnsfq.c
+dnsip.c
+dnsmxip.c
+dnsptr.c
+hostname.c
+ipmeprint.c
+tcp-env.c
+sendmail.c
+qreceipt.c
+qsmhook.c
+qbiff.c
+forward.c
+preline.c
+predate.c
+except.c
+bouncesaying.c
+condredirect.c
+maildirmake.c
+maildir2mbox.c
+maildirwatch.c
+splogger.c
+qail.sh
+elq.sh
+pinq.sh
+qmail-upq.sh
+datemail.sh
+mailsubj.sh
+qlx.h
+rcpthosts.h
+rcpthosts.c
+commands.h
+commands.c
+dnsdoe.h
+dnsdoe.c
+fmtqfn.h
+fmtqfn.c
+gfrom.h
+gfrom.c
+myctime.h
+myctime.c
+newfield.h
+newfield.c
+qsutil.h
+qsutil.c
+readsubdir.h
+readsubdir.c
+received.h
+received.c
+tcpto.h
+tcpto.c
+tcpto_clean.c
+trigger.h
+trigger.c
+triggerpull.h
+triggerpull.c
+trynpbg1.c
+trysyslog.c
+conf-cc
+conf-ld
+home.sh
+home+df.sh
+proc.sh
+proc+df.sh
+binm1.sh
+binm2.sh
+binm3.sh
+binm1+df.sh
+binm2+df.sh
+binm3+df.sh
+find-systype.sh
+make-compile.sh
+make-load.sh
+make-makelib.sh
+trycpp.c
+warn-auto.sh
+auto-str.c
+auto-int.c
+auto-int8.c
+auto-gid.c
+auto-uid.c
+hier.c
+install.c
+instcheck.c
+install-big.c
+alloc.3
+alloc.h
+alloc.c
+alloc_re.c
+case.3
+case.h
+case_diffb.c
+case_diffs.c
+case_lowerb.c
+case_lowers.c
+case_starts.c
+cdb.3
+cdb.h
+cdb_hash.c
+cdb_seek.c
+cdb_unpack.c
+cdbmake.h
+cdbmake_add.c
+cdbmake_hash.c
+cdbmake_pack.c
+cdbmss.h
+cdbmss.c
+coe.3
+coe.h
+coe.c
+fd.h
+fd_copy.3
+fd_copy.c
+fd_move.3
+fd_move.c
+fifo_make.3
+fifo.h
+fifo.c
+trymkffo.c
+fork.h1
+fork.h2
+tryvfork.c
+now.3
+now.h
+now.c
+open.h
+open_append.c
+open_excl.c
+open_read.c
+open_trunc.c
+open_write.c
+seek.h
+seek_cur.c
+seek_end.c
+seek_set.c
+seek_trunc.c
+conf-qmail
+auto_qmail.h
+qmail.h
+qmail.c
+gen_alloc.h
+gen_allocdefs.h
+stralloc.3
+stralloc.h
+stralloc_eady.c
+stralloc_pend.c
+stralloc_copy.c
+stralloc_opyb.c
+stralloc_opys.c
+stralloc_cat.c
+stralloc_catb.c
+stralloc_cats.c
+stralloc_arts.c
+strerr.h
+strerr_sys.c
+strerr_die.c
+substdio.h
+substdio.c
+substdi.c
+substdo.c
+substdio_copy.c
+subfd.h
+subfderr.c
+subfdouts.c
+subfdout.c
+subfdins.c
+subfdin.c
+readwrite.h
+exit.h
+timeoutconn.h
+timeoutconn.c
+timeoutread.h
+timeoutread.c
+timeoutwrite.h
+timeoutwrite.c
+remoteinfo.h
+remoteinfo.c
+uint32.h1
+uint32.h2
+tryulong32.c
+wait.3
+wait.h
+wait_pid.c
+wait_nohang.c
+trywaitp.c
+sig.h
+sig_alarm.c
+sig_block.c
+sig_catch.c
+sig_pause.c
+sig_pipe.c
+sig_child.c
+sig_term.c
+sig_hup.c
+sig_misc.c
+sig_bug.c
+trysgact.c
+trysgprm.c
+env.3
+env.h
+env.c
+envread.c
+byte.h
+byte_chr.c
+byte_copy.c
+byte_cr.c
+byte_diff.c
+byte_rchr.c
+byte_zero.c
+str.h
+str_chr.c
+str_cpy.c
+str_diff.c
+str_diffn.c
+str_len.c
+str_rchr.c
+str_start.c
+lock.h
+lock_ex.c
+lock_exnb.c
+lock_un.c
+tryflock.c
+getln.3
+getln.h
+getln.c
+getln2.3
+getln2.c
+sgetopt.3
+sgetopt.h
+sgetopt.c
+subgetopt.3
+subgetopt.h
+subgetopt.c
+error.3
+error_str.3
+error_temp.3
+error.h
+error.c
+error_str.c
+error_temp.c
+fmt.h
+fmt_str.c
+fmt_strn.c
+fmt_uint.c
+fmt_uint0.c
+fmt_ulong.c
+scan.h
+scan_ulong.c
+scan_8long.c
+slurpclose.h
+slurpclose.c
+quote.h
+quote.c
+hfield.h
+hfield.c
+headerbody.h
+headerbody.c
+token822.h
+token822.c
+control.h
+control.c
+datetime.3
+datetime.h
+datetime.c
+datetime_un.c
+prioq.h
+prioq.c
+date822fmt.h
+date822fmt.c
+dns.h
+dns.c
+trylsock.c
+tryrsolv.c
+ip.h
+ip.c
+ipalloc.h
+ipalloc.c
+select.h1
+select.h2
+trysysel.c
+ndelay.h
+ndelay.c
+ndelay_off.c
+direntry.3
+direntry.h1
+direntry.h2
+trydrent.c
+prot.h
+prot.c
+chkshsgr.c
+warn-shsgr
+tryshsgr.c
+ipme.h
+ipme.c
+trysalen.c
+maildir.5
+maildir.h
+maildir.c
+tcp-environ.5
+constmap.h
+constmap.c
diff --speed-large-files --minimal -Nru tmp/netqmail-1.06/LICENSE.authentication work/netqmail-1.06/LICENSE.authentication
--- tmp/netqmail-1.06/LICENSE.authentication	1969-12-31 18:00:00.000000000 -0600
+++ work/netqmail-1.06/LICENSE.authentication	2016-05-06 14:30:55.000000000 -0500
@@ -0,0 +1,43 @@
+AUTHOR
+======
+
+Author:
+	Dr. Erwin Hoffmann - FEHCom Germany
+Web-Site: 	
+	http://www.fehcom.de/qmail.html
+E-Mail: 	
+	feh@fehcom.de
+
+
+LICENSE
+=======
+
+qmail AUTHENTICATION is free software.
+This includes:
+	You can download and use qmail AUTHENTICATION (and parts of it) as you like.
+	You can modify the source code without notification to or permission by the author.
+Please check:
+	http://www.cr.yp.to/softwarelaw.html
+
+
+DEPENDENCIES
+============
+
+qmail AUTHENTICATION patches (modifies) parts of the qmail-1.03 source files.
+It should only be applied against the source as supplied by D.J. Bernstein.
+
+
+FITNESS
+=======
+
+The Author does not guarantee a specific fitness of qmail AUTHENTICATION.
+If you use qmail AUTHENTICATION, it's on your own risk.
+
+
+DISTRIBUTION
+============
+
+qmail AUTHENTICATION may be included in ports and packages under the following conditions:
+	The port/package has to show the current version number of qmail AUTHENTICATION.
+	All files (namely this) have to be included.
+
diff --speed-large-files --minimal -Nru tmp/netqmail-1.06/Makefile work/netqmail-1.06/Makefile
--- tmp/netqmail-1.06/Makefile	2007-11-30 14:22:54.000000000 -0600
+++ work/netqmail-1.06/Makefile	2016-05-06 14:32:04.000000000 -0500
@@ -1,5 +1,7 @@
 # Don't edit Makefile! Use conf-* for configuration.
 
+DEFINES=-DEXTERNAL_TODO # use to enable external todo
+
 SHELL=/bin/sh
 
 default: it
@@ -136,6 +138,18 @@
 compile auto_usera.c
 	./compile auto_usera.c
 
+base64.o: \
+compile base64.c base64.h stralloc.h substdio.h str.h
+	./compile base64.c
+
+md5c.o : \
+compile md5c.c md5.h
+	./compile md5c.c
+
+hmac_md5.o : \
+compile hmac_md5.c hmac_md5.h global.h
+	./compile hmac_md5.c
+
 binm1: \
 binm1.sh conf-qmail
 	cat binm1.sh \
@@ -703,7 +717,7 @@
 
 hier.o: \
 compile hier.c auto_qmail.h auto_split.h auto_uids.h fmt.h fifo.h
-	./compile hier.c
+	./compile $(DEFINES) hier.c
 
 home: \
 home.sh conf-qmail
@@ -755,7 +769,7 @@
 install-big.o: \
 compile install-big.c auto_qmail.h auto_split.h auto_uids.h fmt.h \
 fifo.h
-	./compile install-big.c
+	./compile $(DEFINES) install-big.c
 
 install.o: \
 compile install.c substdio.h strerr.h error.h open.h readwrite.h \
@@ -808,7 +822,7 @@
 forward preline condredirect bouncesaying except maildirmake \
 maildir2mbox maildirwatch qail elq pinq idedit install-big install \
 instcheck home home+df proc proc+df binm1 binm1+df binm2 binm2+df \
-binm3 binm3+df
+binm3 binm3+df qmail-todo update_tmprsadh
 
 load: \
 make-load warn-auto.sh systype
@@ -1441,12 +1455,16 @@
 load qmail-remote.o control.o constmap.o timeoutread.o timeoutwrite.o \
 timeoutconn.o tcpto.o now.o dns.o ip.o ipalloc.o ipme.o quote.o \
 ndelay.a case.a sig.a open.a lock.a seek.a getln.a stralloc.a alloc.a \
-substdio.a error.a str.a fs.a auto_qmail.o dns.lib socket.lib
+substdio.a error.a str.a fs.a auto_qmail.o \
+base64.o md5c.o hmac_md5.o \
+dns.lib socket.lib
 	./load qmail-remote control.o constmap.o timeoutread.o \
 	timeoutwrite.o timeoutconn.o tcpto.o now.o dns.o ip.o \
+	tls.o ssl_timeoutio.o -L/usr/local/ssl/lib -lssl -lcrypto \
 	ipalloc.o ipme.o quote.o ndelay.a case.a sig.a open.a \
 	lock.a seek.a getln.a stralloc.a alloc.a substdio.a error.a \
-	str.a fs.a auto_qmail.o  `cat dns.lib` `cat socket.lib`
+	base64.o md5c.o hmac_md5.o \
+	str.a fs.a auto_qmail.o `cat dns.lib` `cat socket.lib`
 
 qmail-remote.0: \
 qmail-remote.8
@@ -1509,7 +1527,7 @@
 scan.h case.h auto_qmail.h trigger.h newfield.h stralloc.h quote.h \
 qmail.h substdio.h qsutil.h prioq.h datetime.h gen_alloc.h constmap.h \
 fmtqfn.h readsubdir.h direntry.h
-	./compile qmail-send.c
+	./compile $(DEFINES) qmail-send.c
 
 qmail-showctl: \
 load qmail-showctl.o auto_uids.o control.o open.a getln.a stralloc.a \
@@ -1536,12 +1554,13 @@
 timeoutwrite.o ip.o ipme.o ipalloc.o control.o constmap.o received.o \
 date822fmt.o now.o qmail.o cdb.a fd.a wait.a datetime.a getln.a \
 open.a sig.a case.a env.a stralloc.a alloc.a substdio.a error.a str.a \
-fs.a auto_qmail.o socket.lib
+fs.a auto_qmail.o base64.o socket.lib
 	./load qmail-smtpd rcpthosts.o commands.o timeoutread.o \
 	timeoutwrite.o ip.o ipme.o ipalloc.o control.o constmap.o \
+	tls.o ssl_timeoutio.o ndelay.a -L/usr/local/ssl/lib -lssl -lcrypto \
 	received.o date822fmt.o now.o qmail.o cdb.a fd.a wait.a \
 	datetime.a getln.a open.a sig.a case.a env.a stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a auto_qmail.o  `cat \
+	alloc.a substdio.a error.a str.a fs.a auto_qmail.o base64.o  `cat \
 	socket.lib`
 
 qmail-smtpd.0: \
@@ -1553,7 +1572,7 @@
 substdio.h alloc.h auto_qmail.h control.h received.h constmap.h \
 error.h ipme.h ip.h ipalloc.h ip.h gen_alloc.h ip.h qmail.h \
 substdio.h str.h fmt.h scan.h byte.h case.h env.h now.h datetime.h \
-exit.h rcpthosts.h timeoutread.h timeoutwrite.h commands.h
+exit.h rcpthosts.h timeoutread.h timeoutwrite.h commands.h base64.h
 	./compile qmail-smtpd.c
 
 qmail-start: \
@@ -1574,7 +1593,7 @@
 
 qmail-start.o: \
 compile qmail-start.c fd.h prot.h exit.h fork.h auto_uids.h
-	./compile qmail-start.c
+	./compile $(DEFINES) qmail-start.c
 
 qmail-tcpok: \
 load qmail-tcpok.o open.a lock.a strerr.a substdio.a error.a str.a \
@@ -1606,6 +1625,20 @@
 fmt.h ip.h lock.h error.h exit.h datetime.h now.h datetime.h
 	./compile qmail-tcpto.c
 
+qmail-todo: \
+load qmail-todo.o control.o constmap.o trigger.o fmtqfn.o now.o \
+readsubdir.o case.a ndelay.a getln.a sig.a open.a stralloc.a alloc.a \
+substdio.a error.a str.a fs.a auto_qmail.o auto_split.o
+	./load qmail-todo control.o constmap.o trigger.o fmtqfn.o now.o \
+	readsubdir.o case.a ndelay.a getln.a sig.a open.a stralloc.a \
+	alloc.a substdio.a error.a str.a fs.a auto_qmail.o auto_split.o
+
+qmail-todo.o: \
+compile alloc.h auto_qmail.h byte.h constmap.h control.h direntry.h error.h \
+exit.h fmt.h fmtqfn.h getln.h open.h ndelay.h now.h readsubdir.h readwrite.h \
+scan.h select.h str.h stralloc.h substdio.h trigger.h
+	./compile $(DEFINES) qmail-todo.c
+
 qmail-upq: \
 warn-auto.sh qmail-upq.sh conf-qmail conf-break conf-split
 	cat warn-auto.sh qmail-upq.sh \
@@ -1827,7 +1860,8 @@
 ipalloc.h ipalloc.c select.h1 select.h2 trysysel.c ndelay.h ndelay.c \
 ndelay_off.c direntry.3 direntry.h1 direntry.h2 trydrent.c prot.h \
 prot.c chkshsgr.c warn-shsgr tryshsgr.c ipme.h ipme.c trysalen.c \
-maildir.5 maildir.h maildir.c tcp-environ.5 constmap.h constmap.c
+maildir.5 maildir.h maildir.c tcp-environ.5 constmap.h constmap.c \
+update_tmprsadh
 	shar -m `cat FILES` > shar
 	chmod 400 shar
 
@@ -2108,6 +2142,19 @@
 compile timeoutwrite.c timeoutwrite.h select.h error.h readwrite.h
 	./compile timeoutwrite.c
 
+qmail-smtpd: tls.o ssl_timeoutio.o ndelay.a
+qmail-remote: tls.o ssl_timeoutio.o
+qmail-smtpd.o: tls.h ssl_timeoutio.h
+qmail-remote.o: tls.h ssl_timeoutio.h
+
+tls.o: \
+compile tls.c exit.h error.h
+	./compile tls.c
+
+ssl_timeoutio.o: \
+compile ssl_timeoutio.c ssl_timeoutio.h select.h error.h ndelay.h
+	./compile ssl_timeoutio.c
+
 token822.o: \
 compile token822.c stralloc.h gen_alloc.h alloc.h str.h token822.h \
 gen_alloc.h gen_allocdefs.h
@@ -2139,3 +2186,26 @@
 wait_pid.o: \
 compile wait_pid.c error.h haswaitp.h
 	./compile wait_pid.c
+
+cert cert-req: \
+Makefile-cert
+	@$(MAKE) -sf $< $@
+
+Makefile-cert: \
+conf-qmail conf-users conf-groups Makefile-cert.mk
+	@cat Makefile-cert.mk \
+	| sed s}QMAIL}"`head -1 conf-qmail`"}g \
+	> $@
+
+update_tmprsadh: \
+conf-qmail conf-users conf-groups update_tmprsadh.sh
+	@cat update_tmprsadh.sh\
+	| sed s}UGQMAILD}"`head -2 conf-users|tail -1`:`head -1 conf-groups`"}g \
+	| sed s}QMAIL}"`head -1 conf-qmail`"}g \
+	> $@
+	chmod 755 update_tmprsadh 
+
+tmprsadh: \
+update_tmprsadh
+	echo "Creating new temporary RSA and DH parameters"
+	./update_tmprsadh
diff --speed-large-files --minimal -Nru tmp/netqmail-1.06/Makefile-cert.mk work/netqmail-1.06/Makefile-cert.mk
--- tmp/netqmail-1.06/Makefile-cert.mk	1969-12-31 18:00:00.000000000 -0600
+++ work/netqmail-1.06/Makefile-cert.mk	2016-05-06 14:30:55.000000000 -0500
@@ -0,0 +1,21 @@
+cert-req: req.pem
+cert cert-req: QMAIL/control/clientcert.pem
+	@:
+
+QMAIL/control/clientcert.pem: QMAIL/control/servercert.pem
+	ln -s $< $@
+
+QMAIL/control/servercert.pem:
+	PATH=$$PATH:/usr/local/ssl/bin \
+		openssl req -new -x509 -nodes -days 366 -out $@ -keyout $@
+	chmod 640 $@
+	chown `head -2 conf-users | tail -1`:`head -1 conf-groups` $@
+
+req.pem:
+	PATH=$$PATH:/usr/local/ssl/bin openssl req \
+		-new -nodes -out $@ -keyout QMAIL/control/servercert.pem
+	chmod 640 QMAIL/control/servercert.pem
+	chown `head -2 conf-users | tail -1`:`head -1 conf-groups` QMAIL/control/servercert.pem
+	@echo
+	@echo "Send req.pem to your CA to obtain signed_req.pem, and do:"
+	@echo "cat signed_req.pem >> QMAIL/control/servercert.pem"
